const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const space_memberships = sequelize.define(
    'space_memberships',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

role: {
        type: DataTypes.ENUM,
      
      

        values: [

"member",


"moderator",


"admin"

        ],

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"active",


"requested",


"invited",


"banned"

        ],

      },

joined_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  space_memberships.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.space_memberships.belongsTo(db.spaces, {
      as: 'space',
      foreignKey: {
        name: 'spaceId',
      },
      constraints: false,
    });

    db.space_memberships.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.space_memberships.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.space_memberships.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return space_memberships;
};


